unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets;

type
  TForm1 = class(TForm)
    TcpServer1: TTcpServer;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TcpServer1GetThread(Sender: TObject;
      var ClientSocketThread: TClientSocketThread);
    procedure TcpServer1Accept(Sender: TObject;
      ClientSocket: TCustomIpClient);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
 TNaseClientTheread= class(TClientSocketThread)
 private
 FPrikaz:String; // pchoz pkazy
 FData:String;   // pchoz data pro vpis
 protected
 procedure SyncProc;override;  // procedura pro chrnn vlis do formule
 end;
var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
form1.ListBox1.Clear;
form1.ListBox2.Clear;
form1.TcpServer1.LocalPort:='5050';
form1.TcpServer1.Active:=true;
end;

procedure TNaseClientTheread.SyncProc;
begin
if FPrikaz= 'CLR' then  Form1.ListBox2.Clear
 else if FPrikaz= 'TXT' then Form1.ListBox2.Items.Add(FData)
  else if FPrikaz= 'BYE'  then  begin
  Terminate;
  Form1.ListBox1.Items.Add('Odpojen> '+ClientSocket.RemoteHost);
  end
  else if FPrikaz= '' then
  Form1.ListBox1.Items.Add('Pripojen> '+ClientSocket.RemoteHost);
end;

procedure TForm1.TcpServer1GetThread(Sender: TObject;
  var ClientSocketThread: TClientSocketThread);
begin
// to je pchoz komunikace
 ClientSocketThread:= TNaseClientTheread.Create(TcpServer1.ServerSocketThread)
end;

procedure TForm1.TcpServer1Accept(Sender: TObject;
  ClientSocket: TCustomIpClient);
begin
with (ClientSocket.GetThreadObject as TNaseClientTheread) do begin
FPrikaz:='';
ExecuteSyncProc;
 while not Terminated do begin
 FPrikaz:=ClientSocket.Receiveln;
  if  FPrikaz='TXT' then FData:=ClientSocket.Receiveln;
  if  FPrikaz<>'' then  ExecuteSyncProc;
 end;
end;
end;
end.
